#pragma once
class asITypeInfo;
class asIScriptObject;
class asIScriptFunction;

namespace Deer {
    namespace UIEngine {
        struct DockPanelObject {
        private:
            asITypeInfo* type = nullptr;
            asIScriptObject* object = nullptr;
            asIScriptFunction* renderFunction = nullptr;
            bool isValid = false;
            

        public:
            DockPanelObject(asITypeInfo*);
            ~DockPanelObject();
            // Delete copy constructor
            DockPanelObject(const DockPanelObject&) = delete;
            DockPanelObject& operator=(const DockPanelObject&) = delete;

            DockPanelObject(DockPanelObject&& other) noexcept;
            DockPanelObject& operator=(DockPanelObject&& other) noexcept;
            
            void executeRender();
            inline void invalidate() { isValid = false; }
        };
    }
}