#pragma once
#include <vector>

class asIScriptEngine;
class asIScriptObject;
class asIScriptModule;
class asIScriptContext;

namespace Deer {
    namespace UIEngine {
        struct DockPanelObject;

        extern asIScriptEngine* scriptEngine;
		extern asIScriptModule* scriptModule;
		extern asIScriptContext* scriptContext;
        extern std::vector<DockPanelObject> dockPanels;
        extern DockPanelObject* currentDockPanelExecution;

        void loadScripts();
        void registerUIEngineFunctions();
        void registerDockPanel();
        void extractDockPanels();
    }
}